// TestClientAX_VCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestClientAX_VC.h"
#include "TestClientAX_VCDlg.h"
#include ".\testclientax_vcdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestClientAX_VCDlg dialog



CTestClientAX_VCDlg::CTestClientAX_VCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestClientAX_VCDlg::IDD, pParent)

{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestClientAX_VCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT9, m_edLog);
	DDX_Control(pDX, IDC_TFTPCLIENTCONTROL2, client);
	DDX_Control(pDX, IDC_EDIT8, m_edRemFile);
	DDX_Control(pDX, IDC_EDIT10, m_edLocFile);

}

BEGIN_MESSAGE_MAP(CTestClientAX_VCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
END_MESSAGE_MAP()


// CTestClientAX_VCDlg message handlers

BOOL CTestClientAX_VCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	OnBnClickedButton1();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestClientAX_VCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestClientAX_VCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestClientAX_VCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
BEGIN_EVENTSINK_MAP(CTestClientAX_VCDlg, CDialog)
	ON_EVENT(CTestClientAX_VCDlg, IDC_TFTPCLIENTCONTROL2, 1, OnTransferStartTftpclientcontrol2, VTS_NONE)
	ON_EVENT(CTestClientAX_VCDlg, IDC_TFTPCLIENTCONTROL2, 2, OnTransferCompleteTftpclientcontrol2, VTS_UI4)
	ON_EVENT(CTestClientAX_VCDlg, IDC_TFTPCLIENTCONTROL2, 3, OnConnectTftpclientcontrol2, VTS_NONE)
	ON_EVENT(CTestClientAX_VCDlg, IDC_TFTPCLIENTCONTROL2, 4, OnDisconnectTftpclientcontrol2, VTS_NONE)
	ON_EVENT(CTestClientAX_VCDlg, IDC_TFTPCLIENTCONTROL2, 5, OnProgressTftpclientcontrol2, VTS_UI4 VTS_UI4)
END_EVENTSINK_MAP()

void CTestClientAX_VCDlg::OnTransferStartTftpclientcontrol2()
{
	LogMsg("Transfer start.\r\n");
}

void CTestClientAX_VCDlg::OnTransferCompleteTftpclientcontrol2(unsigned long BytesTransferred)
{
	char buf[128];
	sprintf (buf, "Transfer complete. BytesTransfered = %d\r\n", BytesTransferred);
	LogMsg(buf);
}

void CTestClientAX_VCDlg::OnConnectTftpclientcontrol2()
{
	LogMsg("Connect.\r\n");
}

void CTestClientAX_VCDlg::OnDisconnectTftpclientcontrol2()
{
	LogMsg("Disconnect.\r\n");
}

void CTestClientAX_VCDlg::OnBnClickedButton3()
{
	char rembuf[128], locbuf[128];
	m_edRemFile.GetWindowText(rembuf,128);
	m_edLocFile.GetWindowText(locbuf,128);
	client.RecvFile(rembuf,locbuf);
}

void CTestClientAX_VCDlg::OnBnClickedButton4()
{
	char rembuf[128], locbuf[128];
	m_edRemFile.GetWindowText(rembuf,128);
	m_edLocFile.GetWindowText(locbuf,128);
	client.SendFile(rembuf,locbuf);
}

void CTestClientAX_VCDlg::LogMsg(char *msg)
{
	int lc = m_edLog.GetLineCount();
	if (lc==500) {
		m_edLog.SetSel(m_edLog.LineIndex(498),m_edLog.LineIndex(500));
		m_edLog.ReplaceSel("");
	}
	m_edLog.SetSel(0,0);
	m_edLog.ReplaceSel(msg);
}

void CTestClientAX_VCDlg::OnProgressTftpclientcontrol2(unsigned long PercentDone, unsigned long BytesTransferred)
{
	char buf[256];
	if (PercentDone != 0xFFFFFFFF) {
		sprintf (buf, "Progress - BytesTransfered = %d, PercentDone = %d\r\n", BytesTransferred, PercentDone);
	}
	else {
		sprintf (buf, "Progress - BytesTransfered = %d\r\n", BytesTransferred);
	}
	LogMsg(buf);

}

void CTestClientAX_VCDlg::OnBnClickedButton1()
{
	SetDlgItemInt(IDC_EDIT1,client.get_Retries());
	SetDlgItemInt(IDC_EDIT2,client.get_Timeout());
	SetDlgItemInt(IDC_EDIT3,client.get_Port());
	SetDlgItemInt(IDC_EDIT4,client.get_Mode());
	SetDlgItemText(IDC_EDIT5,client.get_Server());
}

void CTestClientAX_VCDlg::OnBnClickedButton2()
{
	client.put_Retries(GetDlgItemInt(IDC_EDIT1));
	client.put_Timeout(GetDlgItemInt(IDC_EDIT2));
	client.put_Port(GetDlgItemInt(IDC_EDIT3));
	client.put_Mode(GetDlgItemInt(IDC_EDIT4));
	char buf[128];
	GetDlgItemText(IDC_EDIT5, buf, 128);
	client.put_Server(buf);
}

void CTestClientAX_VCDlg::OnBnClickedButton5()
{
	char buf1[128];
	GetDlgItemText(IDC_EDIT6, buf1, 128);
	char buf2[128];
	GetDlgItemText(IDC_EDIT7, buf2, 128);

	client.SetOption(buf1,buf2);
}

void CTestClientAX_VCDlg::OnBnClickedButton6()
{
	client.ClearOptions();
}
